Index: uspace/lib/usbhid/src/hidparser.c
===================================================================
--- uspace/lib/usbhid/src/hidparser.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhid/src/hidparser.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -127,5 +127,5 @@
  * @return Error code.
  */ 
-errno_t usb_hid_parse_report(const usb_hid_report_t *report, const uint8_t *data, 
+int usb_hid_parse_report(const usb_hid_report_t *report, const uint8_t *data, 
     size_t size, uint8_t *report_id)
 {
@@ -334,5 +334,5 @@
  * @return Error code
  */
-errno_t usb_hid_report_output_translate(usb_hid_report_t *report, 
+int usb_hid_report_output_translate(usb_hid_report_t *report, 
     uint8_t report_id, uint8_t *buffer, size_t size)
 {
@@ -531,5 +531,5 @@
 
 			if (usb_hid_report_compare_usage_path(
-			    field->collection_path, path, flags) == 0) {
+			    field->collection_path, path, flags) == EOK) {
 				usb_hid_report_remove_last_item(
 				    field->collection_path);
Index: uspace/lib/usbhid/src/hidpath.c
===================================================================
--- uspace/lib/usbhid/src/hidpath.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhid/src/hidpath.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -73,5 +73,5 @@
  * @return Error code
  */
-errno_t usb_hid_report_path_append_item(usb_hid_report_path_t *usage_path, 
+int usb_hid_report_path_append_item(usb_hid_report_path_t *usage_path, 
                                     int32_t usage_page, int32_t usage)
 {	
@@ -191,5 +191,5 @@
  * @param flags       Flags determining the mode of comparison
  *
- * @return 0 if both paths are identical, non zero number otherwise
+ * @return EOK if both paths are identical, non zero number otherwise
  *
  */
@@ -213,5 +213,5 @@
 	// Empty path match all others
 	if (path->depth == 0) {
-		return 0;
+		return EOK;
 	}
 	
@@ -239,7 +239,7 @@
 					if (USB_HID_SAME_USAGE(report_item->usage,
 					    path_item->usage))
-						return 0;
+						return EOK;
 				} else {
-					return 0;
+					return EOK;
 				}
 			}
@@ -285,5 +285,5 @@
 		    ((report_link == &report_path->items.head) &&
 		    (path_link == &path->items.head))) {
-			return 0;
+			return EOK;
 		} else {
 			return 1;
@@ -297,5 +297,5 @@
 		
 		if (list_empty(&path->items)) {
-			return 0;
+			return EOK;
 		}
 		
@@ -320,5 +320,5 @@
 		
 		if (path_link == &path->items.head) {
-			return 0;
+			return EOK;
 		} else {
 			return 1;
@@ -327,5 +327,5 @@
 	
 	default:
-		return -1;
+		return EINVAL;
 	}
 }
@@ -423,5 +423,5 @@
  * @return Error code
  */
-errno_t usb_hid_report_path_set_report_id(usb_hid_report_path_t *path, 
+int usb_hid_report_path_set_report_id(usb_hid_report_path_t *path, 
 	uint8_t report_id)
 {
Index: uspace/lib/usbhid/src/hidreport.c
===================================================================
--- uspace/lib/usbhid/src/hidreport.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhid/src/hidreport.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,5 +50,5 @@
 #include <usb/hid/hidreport.h>
 
-static errno_t usb_hid_get_report_descriptor(usb_device_t *dev,
+static int usb_hid_get_report_descriptor(usb_device_t *dev,
     uint8_t **report_desc, size_t *size)
 {
@@ -135,5 +135,5 @@
 	 * Get the descriptor from the device.
 	 */
-	errno_t rc = usb_request_get_descriptor(usb_device_get_default_pipe(dev),
+	int rc = usb_request_get_descriptor(usb_device_get_default_pipe(dev),
 	    USB_REQUEST_TYPE_STANDARD, USB_REQUEST_RECIPIENT_INTERFACE,
 	    USB_DESCTYPE_HID_REPORT, 0, usb_device_get_iface_number(dev),
@@ -163,5 +163,5 @@
 
 
-errno_t usb_hid_process_report_descriptor(usb_device_t *dev, 
+int usb_hid_process_report_descriptor(usb_device_t *dev, 
     usb_hid_report_t *report, uint8_t **report_desc, size_t *report_size)
 {
@@ -175,5 +175,5 @@
 //	size_t report_size;
 	
-	errno_t rc = usb_hid_get_report_descriptor(dev, report_desc, report_size);
+	int rc = usb_hid_get_report_descriptor(dev, report_desc, report_size);
 	
 	if (rc != EOK) {
Index: uspace/lib/usbhid/src/hidreq.c
===================================================================
--- uspace/lib/usbhid/src/hidreq.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhid/src/hidreq.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,5 +58,5 @@
  * @return Other value inherited from function usb_control_request_set().
  */
-errno_t usbhid_req_set_report(usb_pipe_t *ctrl_pipe, int iface_no,
+int usbhid_req_set_report(usb_pipe_t *ctrl_pipe, int iface_no,
     usb_hid_report_type_t type, uint8_t *buffer, size_t buf_size)
 {
@@ -77,5 +77,5 @@
 	 */
 	
-	errno_t rc;
+	int rc;
 	
 	uint16_t value = 0;
@@ -108,5 +108,5 @@
  * @return Other value inherited from function usb_control_request_set().
  */
-errno_t usbhid_req_set_protocol(usb_pipe_t *ctrl_pipe, int iface_no,
+int usbhid_req_set_protocol(usb_pipe_t *ctrl_pipe, int iface_no,
     usb_hid_protocol_t protocol)
 {
@@ -127,5 +127,5 @@
 	 */
 	
-	errno_t rc;
+	int rc;
 
 	usb_log_debug("Sending Set Protocol request to the device ("
@@ -157,23 +157,23 @@
  * @return Other value inherited from function usb_control_request_set().
  */
-errno_t usbhid_req_set_idle(usb_pipe_t *ctrl_pipe, int iface_no, uint8_t duration)
-{
-	if (ctrl_pipe == NULL) {
-		usb_log_warning("usbhid_req_set_report(): no pipe given.\n");
-		return EINVAL;
-	}
-	
-	if (iface_no < 0) {
-		usb_log_warning("usbhid_req_set_report(): no interface given."
-		    "\n");
-		return EINVAL;
-	}
-	
-	/*
-	 * No need for checking other parameters, as they are checked in
-	 * the called function (usb_control_request_set()).
-	 */
-	
-	errno_t rc;
+int usbhid_req_set_idle(usb_pipe_t *ctrl_pipe, int iface_no, uint8_t duration)
+{
+	if (ctrl_pipe == NULL) {
+		usb_log_warning("usbhid_req_set_report(): no pipe given.\n");
+		return EINVAL;
+	}
+	
+	if (iface_no < 0) {
+		usb_log_warning("usbhid_req_set_report(): no interface given."
+		    "\n");
+		return EINVAL;
+	}
+	
+	/*
+	 * No need for checking other parameters, as they are checked in
+	 * the called function (usb_control_request_set()).
+	 */
+	
+	int rc;
 
 	usb_log_debug("Sending Set Idle request to the device ("
@@ -210,5 +210,5 @@
  * @return Other value inherited from function usb_control_request_set().
  */
-errno_t usbhid_req_get_report(usb_pipe_t *ctrl_pipe, int iface_no, 
+int usbhid_req_get_report(usb_pipe_t *ctrl_pipe, int iface_no, 
     usb_hid_report_type_t type, uint8_t *buffer, size_t buf_size, 
     size_t *actual_size)
@@ -230,5 +230,5 @@
 	 */
 	
-	errno_t rc;
+	int rc;
 
 	uint16_t value = 0;
@@ -262,5 +262,5 @@
  * @return Other value inherited from function usb_control_request_set().
  */
-errno_t usbhid_req_get_protocol(usb_pipe_t *ctrl_pipe, int iface_no, 
+int usbhid_req_get_protocol(usb_pipe_t *ctrl_pipe, int iface_no, 
     usb_hid_protocol_t *protocol)
 {
@@ -281,5 +281,5 @@
 	 */
 	
-	errno_t rc;	
+	int rc;	
 
 	usb_log_debug("Sending Get Protocol request to the device ("
@@ -324,23 +324,23 @@
  *         usb_control_request_set().
  */
-errno_t usbhid_req_get_idle(usb_pipe_t *ctrl_pipe, int iface_no, uint8_t *duration)
-{
-	if (ctrl_pipe == NULL) {
-		usb_log_warning("usbhid_req_set_report(): no pipe given.\n");
-		return EINVAL;
-	}
-	
-	if (iface_no < 0) {
-		usb_log_warning("usbhid_req_set_report(): no interface given."
-		    "\n");
-		return EINVAL;
-	}
-	
-	/*
-	 * No need for checking other parameters, as they are checked in
-	 * the called function (usb_control_request_set()).
-	 */
-	
-	errno_t rc;
+int usbhid_req_get_idle(usb_pipe_t *ctrl_pipe, int iface_no, uint8_t *duration)
+{
+	if (ctrl_pipe == NULL) {
+		usb_log_warning("usbhid_req_set_report(): no pipe given.\n");
+		return EINVAL;
+	}
+	
+	if (iface_no < 0) {
+		usb_log_warning("usbhid_req_set_report(): no interface given."
+		    "\n");
+		return EINVAL;
+	}
+	
+	/*
+	 * No need for checking other parameters, as they are checked in
+	 * the called function (usb_control_request_set()).
+	 */
+	
+	int rc;
 
 	usb_log_debug("Sending Get Idle request to the device ("
Index: uspace/lib/usbhost/include/usb/host/ddf_helpers.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/ddf_helpers.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/include/usb/host/ddf_helpers.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,8 +45,8 @@
 #include <device/hw_res_parsed.h>
 
-typedef errno_t (*driver_init_t)(hcd_t *, const hw_res_list_parsed_t *, bool);
+typedef int (*driver_init_t)(hcd_t *, const hw_res_list_parsed_t *, bool);
 typedef void (*driver_fini_t)(hcd_t *);
-typedef errno_t (*claim_t)(ddf_dev_t *);
-typedef errno_t (*irq_code_gen_t)(irq_code_t *, const hw_res_list_parsed_t *, int *);
+typedef int (*claim_t)(ddf_dev_t *);
+typedef int (*irq_code_gen_t)(irq_code_t *, const hw_res_list_parsed_t *);
 
 typedef struct {
@@ -61,20 +61,19 @@
 } ddf_hc_driver_t;
 
-errno_t hcd_ddf_add_hc(ddf_dev_t *device, const ddf_hc_driver_t *driver);
+int hcd_ddf_add_hc(ddf_dev_t *device, const ddf_hc_driver_t *driver);
 
-errno_t hcd_ddf_setup_hc(ddf_dev_t *device, usb_speed_t max_speed,
+int hcd_ddf_setup_hc(ddf_dev_t *device, usb_speed_t max_speed,
     size_t bw, bw_count_func_t bw_count);
 void hcd_ddf_clean_hc(ddf_dev_t *device);
-errno_t hcd_ddf_setup_root_hub(ddf_dev_t *device);
+int hcd_ddf_setup_root_hub(ddf_dev_t *device);
 
 hcd_t *dev_to_hcd(ddf_dev_t *dev);
 
-errno_t hcd_ddf_enable_interrupt(ddf_dev_t *device, int);
-errno_t hcd_ddf_get_registers(ddf_dev_t *device, hw_res_list_parsed_t *hw_res);
-errno_t hcd_ddf_setup_interrupts(ddf_dev_t *device,
+int hcd_ddf_enable_interrupt(ddf_dev_t *device, int);
+int hcd_ddf_get_registers(ddf_dev_t *device, hw_res_list_parsed_t *hw_res);
+int hcd_ddf_setup_interrupts(ddf_dev_t *device,
     const hw_res_list_parsed_t *hw_res,
     interrupt_handler_t handler,
-    errno_t (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *, int *),
-    cap_handle_t *handle);
+    int (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *));
 void ddf_hcd_gen_irq_handler(ipc_call_t *call, ddf_dev_t *dev);
 
Index: uspace/lib/usbhost/include/usb/host/hcd.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/hcd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/include/usb/host/hcd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,9 +49,9 @@
 typedef struct hcd hcd_t;
 
-typedef errno_t (*schedule_hook_t)(hcd_t *, usb_transfer_batch_t *);
-typedef errno_t (*ep_add_hook_t)(hcd_t *, endpoint_t *);
+typedef int (*schedule_hook_t)(hcd_t *, usb_transfer_batch_t *);
+typedef int (*ep_add_hook_t)(hcd_t *, endpoint_t *);
 typedef void (*ep_remove_hook_t)(hcd_t *, endpoint_t *);
 typedef void (*interrupt_hook_t)(hcd_t *, uint32_t);
-typedef errno_t (*status_hook_t)(hcd_t *, uint32_t *);
+typedef int (*status_hook_t)(hcd_t *, uint32_t *);
 
 typedef struct {
@@ -102,27 +102,27 @@
 }
 
-extern errno_t hcd_request_address(hcd_t *, usb_speed_t, usb_address_t *);
+extern usb_address_t hcd_request_address(hcd_t *, usb_speed_t);
 
-extern errno_t hcd_release_address(hcd_t *, usb_address_t);
+extern int hcd_release_address(hcd_t *, usb_address_t);
 
-extern errno_t hcd_reserve_default_address(hcd_t *, usb_speed_t);
+extern int hcd_reserve_default_address(hcd_t *, usb_speed_t);
 
-static inline errno_t hcd_release_default_address(hcd_t *hcd)
+static inline int hcd_release_default_address(hcd_t *hcd)
 {
 	return hcd_release_address(hcd, USB_ADDRESS_DEFAULT);
 }
 
-extern errno_t hcd_add_ep(hcd_t *, usb_target_t, usb_direction_t,
+extern int hcd_add_ep(hcd_t *, usb_target_t, usb_direction_t,
     usb_transfer_type_t, size_t, unsigned int, size_t, usb_address_t,
     unsigned int);
 
-extern errno_t hcd_remove_ep(hcd_t *, usb_target_t, usb_direction_t);
+extern int hcd_remove_ep(hcd_t *, usb_target_t, usb_direction_t);
 
-extern errno_t hcd_send_batch(hcd_t *, usb_target_t, usb_direction_t, void *,
+extern int hcd_send_batch(hcd_t *, usb_target_t, usb_direction_t, void *,
     size_t, uint64_t, usbhc_iface_transfer_in_callback_t,
     usbhc_iface_transfer_out_callback_t, void *, const char *);
 
-extern errno_t hcd_send_batch_sync(hcd_t *, usb_target_t, usb_direction_t,
-    void *, size_t, uint64_t, const char *, size_t *);
+extern ssize_t hcd_send_batch_sync(hcd_t *, usb_target_t, usb_direction_t,
+    void *, size_t, uint64_t, const char *);
 
 #endif
Index: uspace/lib/usbhost/include/usb/host/usb_bus.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_bus.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/include/usb/host/usb_bus.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,5 +58,5 @@
 typedef size_t (*bw_count_func_t)(usb_speed_t, usb_transfer_type_t, size_t, size_t);
 typedef void (*ep_remove_callback_t)(endpoint_t *, void *);
-typedef errno_t (*ep_add_callback_t)(endpoint_t *, void *);
+typedef int (*ep_add_callback_t)(endpoint_t *, void *);
 
 /** Endpoint management structure */
@@ -85,15 +85,15 @@
     size_t size, size_t max_packet_size);
 
-errno_t usb_bus_init(usb_bus_t *instance,
+int usb_bus_init(usb_bus_t *instance,
     size_t available_bandwidth, bw_count_func_t bw_count, usb_speed_t max_speed);
 
-errno_t usb_bus_register_ep(usb_bus_t *instance, endpoint_t *ep, size_t data_size);
+int usb_bus_register_ep(usb_bus_t *instance, endpoint_t *ep, size_t data_size);
 
-errno_t usb_bus_unregister_ep(usb_bus_t *instance, endpoint_t *ep);
+int usb_bus_unregister_ep(usb_bus_t *instance, endpoint_t *ep);
 
-endpoint_t *usb_bus_find_ep(usb_bus_t *instance,
+endpoint_t * usb_bus_find_ep(usb_bus_t *instance,
     usb_address_t address, usb_endpoint_t ep, usb_direction_t direction);
 
-errno_t usb_bus_add_ep(usb_bus_t *instance,
+int usb_bus_add_ep(usb_bus_t *instance,
     usb_address_t address, usb_endpoint_t endpoint, usb_direction_t direction,
     usb_transfer_type_t type, size_t max_packet_size, unsigned packets,
@@ -101,17 +101,17 @@
     usb_address_t tt_address, unsigned tt_port);
 
-errno_t usb_bus_remove_ep(usb_bus_t *instance,
+int usb_bus_remove_ep(usb_bus_t *instance,
     usb_address_t address, usb_endpoint_t endpoint, usb_direction_t direction,
     ep_remove_callback_t callback, void *arg);
 
-errno_t usb_bus_reset_toggle(usb_bus_t *instance, usb_target_t target, bool all);
+int usb_bus_reset_toggle(usb_bus_t *instance, usb_target_t target, bool all);
 
-errno_t usb_bus_remove_address(usb_bus_t *instance,
+int usb_bus_remove_address(usb_bus_t *instance,
     usb_address_t address, ep_remove_callback_t callback, void *arg);
 
-errno_t usb_bus_request_address(usb_bus_t *instance,
+int usb_bus_request_address(usb_bus_t *instance,
     usb_address_t *address, bool strict, usb_speed_t speed);
 
-errno_t usb_bus_get_speed(usb_bus_t *instance,
+int usb_bus_get_speed(usb_bus_t *instance,
     usb_address_t address, usb_speed_t *speed);
 #endif
Index: uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -79,5 +79,5 @@
 	 * with the exception of usb_transfer_batch_finish. For external use.
 	 */
-	errno_t error;
+	int error;
 } usb_transfer_batch_t;
 
@@ -105,8 +105,8 @@
     void *arg
 );
-void usb_transfer_batch_destroy(usb_transfer_batch_t *instance);
+void usb_transfer_batch_destroy(const usb_transfer_batch_t *instance);
 
 void usb_transfer_batch_finish_error(const usb_transfer_batch_t *instance,
-    const void* data, size_t size, errno_t error);
+    const void* data, size_t size, int error);
 
 /** Finish batch using stored error value and transferred size.
Index: uspace/lib/usbhost/include/usb/host/utils/malloc32.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/utils/malloc32.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/include/usb/host/utils/malloc32.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -59,5 +59,5 @@
 {
 	uintptr_t result;
-	errno_t ret = as_get_physical_mapping(addr, &result);
+	int ret = as_get_physical_mapping(addr, &result);
 	
 	if (ret != EOK)
@@ -78,5 +78,5 @@
 	size_t real_size = ALIGN_UP(size, PAGE_SIZE);
 
-	const errno_t ret = dmamem_map_anonymous(real_size,
+	const int ret = dmamem_map_anonymous(real_size,
 	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0, &phys,
 	    &address);
Index: uspace/lib/usbhost/src/ddf_helpers.c
===================================================================
--- uspace/lib/usbhost/src/ddf_helpers.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/src/ddf_helpers.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -91,6 +91,6 @@
 
 
-static errno_t hcd_ddf_new_device(ddf_dev_t *device, usb_dev_t *hub, unsigned port);
-static errno_t hcd_ddf_remove_device(ddf_dev_t *device, usb_dev_t *hub, unsigned port);
+static int hcd_ddf_new_device(ddf_dev_t *device, usb_dev_t *hub, unsigned port);
+static int hcd_ddf_remove_device(ddf_dev_t *device, usb_dev_t *hub, unsigned port);
 
 
@@ -107,5 +107,5 @@
  * @return Error code.
  */
-static errno_t register_endpoint(
+static int register_endpoint(
     ddf_fun_t *fun, usb_endpoint_t endpoint,
     usb_transfer_type_t transfer_type, usb_direction_t direction,
@@ -136,5 +136,5 @@
  * @return Error code.
  */
-static errno_t unregister_endpoint(
+static int unregister_endpoint(
     ddf_fun_t *fun, usb_endpoint_t endpoint, usb_direction_t direction)
 {
@@ -151,5 +151,5 @@
 }
 
-static errno_t reserve_default_address(ddf_fun_t *fun, usb_speed_t speed)
+static int reserve_default_address(ddf_fun_t *fun, usb_speed_t speed)
 {
 	assert(fun);
@@ -164,5 +164,5 @@
 }
 
-static errno_t release_default_address(ddf_fun_t *fun)
+static int release_default_address(ddf_fun_t *fun)
 {
 	assert(fun);
@@ -176,5 +176,5 @@
 }
 
-static errno_t device_enumerate(ddf_fun_t *fun, unsigned port)
+static int device_enumerate(ddf_fun_t *fun, unsigned port)
 {
 	assert(fun);
@@ -188,5 +188,5 @@
 }
 
-static errno_t device_remove(ddf_fun_t *fun, unsigned port)
+static int device_remove(ddf_fun_t *fun, unsigned port)
 {
 	assert(fun);
@@ -206,5 +206,5 @@
  * @return Error code.
  */
-static errno_t get_my_device_handle(ddf_fun_t *fun, devman_handle_t *handle)
+static int get_my_device_handle(ddf_fun_t *fun, devman_handle_t *handle)
 {
 	assert(fun);
@@ -224,5 +224,5 @@
  * @return Error code.
  */
-static errno_t dev_read(ddf_fun_t *fun, usb_endpoint_t endpoint,
+static int dev_read(ddf_fun_t *fun, usb_endpoint_t endpoint,
     uint64_t setup_data, uint8_t *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
@@ -250,5 +250,5 @@
  * @return Error code.
  */
-static errno_t dev_write(ddf_fun_t *fun, usb_endpoint_t endpoint,
+static int dev_write(ddf_fun_t *fun, usb_endpoint_t endpoint,
     uint64_t setup_data, const uint8_t *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
@@ -313,5 +313,5 @@
 };
 
-static errno_t hcd_ddf_add_device(ddf_dev_t *parent, usb_dev_t *hub_dev,
+static int hcd_ddf_add_device(ddf_dev_t *parent, usb_dev_t *hub_dev,
     unsigned port, usb_address_t address, usb_speed_t speed, const char *name,
     const match_id_list_t *mids)
@@ -351,5 +351,5 @@
 	}
 
-	errno_t ret = ddf_fun_bind(fun);
+	int ret = ddf_fun_bind(fun);
 	if (ret != EOK) {
 		ddf_fun_destroy(fun);
@@ -389,5 +389,5 @@
 
 /* This is a copy of lib/usbdev/src/recognise.c */
-static errno_t create_match_ids(match_id_list_t *l,
+static int create_match_ids(match_id_list_t *l,
     usb_standard_device_descriptor_t *d)
 {
@@ -418,5 +418,5 @@
 }
 
-static errno_t hcd_ddf_remove_device(ddf_dev_t *device, usb_dev_t *hub,
+static int hcd_ddf_remove_device(ddf_dev_t *device, usb_dev_t *hub,
     unsigned port)
 {
@@ -443,5 +443,5 @@
 		list_remove(&victim->link);
 		fibril_mutex_unlock(&hub->guard);
-		const errno_t ret = ddf_fun_unbind(victim->fun);
+		const int ret = ddf_fun_unbind(victim->fun);
 		if (ret == EOK) {
 			usb_address_t address = victim->address;
@@ -458,5 +458,5 @@
 }
 
-static errno_t hcd_ddf_new_device(ddf_dev_t *device, usb_dev_t *hub, unsigned port)
+static int hcd_ddf_new_device(ddf_dev_t *device, usb_dev_t *hub, unsigned port)
 {
 	assert(device);
@@ -468,5 +468,5 @@
 
 	/* This checks whether the default address is reserved and gets speed */
-	errno_t ret = usb_bus_get_speed(&hcd->bus, USB_ADDRESS_DEFAULT, &speed);
+	int ret = usb_bus_get_speed(&hcd->bus, USB_ADDRESS_DEFAULT, &speed);
 	if (ret != EOK) {
 		usb_log_error("Failed to verify speed: %s.", str_error(ret));
@@ -481,10 +481,9 @@
 	}};
 
-	usb_address_t address;
-	ret = hcd_request_address(hcd, speed, &address);
-	if (ret != EOK) {
+	const usb_address_t address = hcd_request_address(hcd, speed);
+	if (address < 0) {
 		usb_log_error("Failed to reserve new address: %s.",
-		    str_error(ret));
-		return ret;
+		    str_error(address));
+		return address;
 	}
 
@@ -519,14 +518,10 @@
 	usb_log_debug("Device(%d): Requesting first 8B of device descriptor.",
 	    address);
-	size_t got;
-	ret = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_IN,
+	ssize_t got = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_IN,
 	    &desc, CTRL_PIPE_MIN_PACKET_SIZE, *(uint64_t *)&get_device_desc_8,
-	    "read first 8 bytes of dev descriptor", &got);
-
-	if (ret == EOK && got != CTRL_PIPE_MIN_PACKET_SIZE) {
-		ret = EOVERFLOW;
-	}
-
-	if (ret != EOK) {
+	    "read first 8 bytes of dev descriptor");
+
+	if (got != CTRL_PIPE_MIN_PACKET_SIZE) {
+		ret = got < 0 ? got : EOVERFLOW;
 		usb_log_error("Device(%d): Failed to get 8B of dev descr: %s.",
 		    address, str_error(ret));
@@ -557,16 +552,16 @@
 
 	usb_log_debug("Device(%d): Setting USB address.", address);
-	ret = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_OUT,
-	    NULL, 0, *(uint64_t *)&set_address, "set address", &got);
+	got = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_OUT,
+	    NULL, 0, *(uint64_t *)&set_address, "set address");
 
 	usb_log_debug("Device(%d): Removing default (0:0) EP.", address);
 	hcd_remove_ep(hcd, default_target, USB_DIRECTION_BOTH);
 
-	if (ret != EOK) {
+	if (got != 0) {
 		usb_log_error("Device(%d): Failed to set new address: %s.",
-		    address, str_error(ret));
+		    address, str_error(got));
 		hcd_remove_ep(hcd, target, USB_DIRECTION_BOTH);
 		hcd_release_address(hcd, address);
-		return ret;
+		return got;
 	}
 
@@ -577,7 +572,7 @@
 	usb_log_debug("Device(%d): Requesting full device descriptor.",
 	    address);
-	ret = hcd_send_batch_sync(hcd, target, USB_DIRECTION_IN,
+	got = hcd_send_batch_sync(hcd, target, USB_DIRECTION_IN,
 	    &desc, sizeof(desc), *(uint64_t *)&get_device_desc,
-	    "read device descriptor", &got);
+	    "read device descriptor");
 	if (ret != EOK) {
 		usb_log_error("Device(%d): Failed to set get dev descriptor: %s",
@@ -621,5 +616,5 @@
  * @return Error code
  */
-errno_t hcd_ddf_setup_root_hub(ddf_dev_t *device)
+int hcd_ddf_setup_root_hub(ddf_dev_t *device)
 {
 	assert(device);
@@ -628,5 +623,5 @@
 
 	hcd_reserve_default_address(hcd, hcd->bus.max_speed);
-	const errno_t ret = hcd_ddf_new_device(device, NULL, 0);
+	const int ret = hcd_ddf_new_device(device, NULL, 0);
 	hcd_release_default_address(hcd);
 	return ret;
@@ -643,5 +638,5 @@
  * This function does all the ddf work for hc driver.
  */
-errno_t hcd_ddf_setup_hc(ddf_dev_t *device, usb_speed_t max_speed,
+int hcd_ddf_setup_hc(ddf_dev_t *device, usb_speed_t max_speed,
     size_t bw, bw_count_func_t bw_count)
 {
@@ -656,5 +651,5 @@
 	hcd_init(&instance->hcd, max_speed, bw, bw_count);
 
-	errno_t ret = ENOMEM;
+	int ret = ENOMEM;
 	instance->ctl_fun = ddf_fun_create(device, fun_exposed, "ctl");
 	if (!instance->ctl_fun) {
@@ -691,5 +686,5 @@
 	hc_dev_t *hc = dev_to_hc_dev(device);
 	assert(hc);
-	const errno_t ret = ddf_fun_unbind(hc->ctl_fun);
+	const int ret = ddf_fun_unbind(hc->ctl_fun);
 	if (ret == EOK)
 		ddf_fun_destroy(hc->ctl_fun);
@@ -703,5 +698,5 @@
  * @return Error code.
  */
-errno_t hcd_ddf_enable_interrupt(ddf_dev_t *device, int inum)
+int hcd_ddf_enable_interrupt(ddf_dev_t *device, int inum)
 {
 	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
@@ -713,5 +708,5 @@
 
 //TODO: Cache parent session in HCD
-errno_t hcd_ddf_get_registers(ddf_dev_t *device, hw_res_list_parsed_t *hw_res)
+int hcd_ddf_get_registers(ddf_dev_t *device, hw_res_list_parsed_t *hw_res)
 {
 	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
@@ -720,5 +715,5 @@
 
 	hw_res_list_parsed_init(hw_res);
-	const errno_t ret = hw_res_get_list_parsed(parent_sess, hw_res, 0);
+	const int ret = hw_res_get_list_parsed(parent_sess, hw_res, 0);
 	if (ret != EOK)
 		hw_res_list_parsed_clean(hw_res);
@@ -747,13 +742,11 @@
  * @param[in] gen_irq_code IRQ code generator.
  *
- * @param[out] handle  IRQ capability handle on success.
- *
- * @return Error code.
- */
-errno_t hcd_ddf_setup_interrupts(ddf_dev_t *device,
+ * @return IRQ capability handle on success.
+ * @return Negative error code.
+ */
+int hcd_ddf_setup_interrupts(ddf_dev_t *device,
     const hw_res_list_parsed_t *hw_res,
     interrupt_handler_t handler,
-    errno_t (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *, int *),
-    cap_handle_t *handle)
+    int (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *hw_res))
 {
 
@@ -764,30 +757,30 @@
 	irq_code_t irq_code = {0};
 
-	int irq;
-	errno_t ret = gen_irq_code(&irq_code, hw_res, &irq);
-	if (ret != EOK) {
+	const int irq = gen_irq_code(&irq_code, hw_res);
+	if (irq < 0) {
 		usb_log_error("Failed to generate IRQ code: %s.\n",
-		    str_error(ret));
-		return ret;
+		    str_error(irq));
+		return irq;
 	}
 
 	/* Register handler to avoid interrupt lockup */
-	ret = register_interrupt_handler(device, irq, handler,
-	    &irq_code, handle);
+	const int irq_cap = register_interrupt_handler(device, irq, handler,
+	    &irq_code);
 	irq_code_clean(&irq_code);
+	if (irq_cap < 0) {
+		usb_log_error("Failed to register interrupt handler: %s.\n",
+		    str_error(irq_cap));
+		return irq_cap;
+	}
+
+	/* Enable interrupts */
+	int ret = hcd_ddf_enable_interrupt(device, irq);
 	if (ret != EOK) {
 		usb_log_error("Failed to register interrupt handler: %s.\n",
 		    str_error(ret));
-		return ret;
-	}
-
-	/* Enable interrupts */
-	ret = hcd_ddf_enable_interrupt(device, irq);
-	if (ret != EOK) {
-		usb_log_error("Failed to register interrupt handler: %s.\n",
-		    str_error(ret));
-		unregister_interrupt_handler(device, *handle);
-	}
-	return ret;
+		unregister_interrupt_handler(device, irq_cap);
+		return ret;
+	}
+	return irq_cap;
 }
 
@@ -809,5 +802,5 @@
 }
 
-static errno_t interrupt_polling(void *arg)
+static int interrupt_polling(void *arg)
 {
 	hcd_t *hcd = arg;
@@ -847,5 +840,5 @@
  *  - registers root hub
  */
-errno_t hcd_ddf_add_hc(ddf_dev_t *device, const ddf_hc_driver_t *driver)
+int hcd_ddf_add_hc(ddf_dev_t *device, const ddf_hc_driver_t *driver)
 {
 	assert(driver);
@@ -857,5 +850,5 @@
 	};
 
-	errno_t ret = EOK;
+	int ret = EOK;
 	const usb_speed_t speed = driver->hc_speed;
 	if (speed >= ARRAY_SIZE(bw) || bw[speed].bw == 0) {
@@ -883,19 +876,17 @@
 	interrupt_handler_t *irq_handler =
 	    driver->irq_handler ? driver->irq_handler : ddf_hcd_gen_irq_handler;
-	int irq_cap;
-	errno_t irq_ret = hcd_ddf_setup_interrupts(device, &hw_res,
-	    irq_handler, driver->irq_code_gen, &irq_cap);
-	bool irqs_enabled = (irq_ret == EOK);
+	const int irq_cap = hcd_ddf_setup_interrupts(device, &hw_res,
+	    irq_handler, driver->irq_code_gen);
+	bool irqs_enabled = !(irq_cap < 0);
 	if (irqs_enabled) {
 		usb_log_debug("Hw interrupts enabled.\n");
 	}
 
-	if (driver->claim) {
+	if (driver->claim)
 		ret = driver->claim(device);
-		if (ret != EOK) {
-			usb_log_error("Failed to claim `%s' for driver `%s'",
-			    ddf_dev_get_name(device), driver->name);
-			return ret;
-		}
+	if (ret != EOK) {
+		usb_log_error("Failed to claim `%s' for driver `%s'",
+		    ddf_dev_get_name(device), driver->name);
+		return ret;
 	}
 
@@ -920,5 +911,5 @@
 		fibril_add_ready(hcd->polling_fibril);
 		usb_log_warning("Failed to enable interrupts: %s."
-		    " Falling back to polling.\n", str_error(irq_ret));
+		    " Falling back to polling.\n", str_error(irq_cap));
 	}
 
